from cv2 import cv2
import threading
from threading import Lock
import time


# Solved: Open CV RTSP camera buffer lag Source
# https://stackoverflow.com/questions/60816436/open-cv-rtsp-camera-buffer-lag ,
# https://stackoverflow.com/questions/51722319/skip-frames-and-seek-to-end-of-rtsp-stream-in-opencv

class Camera:
    last_frame = None
    last_ready = None
    lock = Lock()

    def __init__(self, rtsp_link):
        capture = cv2.VideoCapture(rtsp_link)
        thread = threading.Thread(target=self.rtsp_cam_buffer, args=(capture,), name="rtsp_read_thread")
        thread.daemon = True
        thread.start()

    def rtsp_cam_buffer(self, capture):
        while True:
            with self.lock:
                self.last_ready, self.last_frame = capture.read()

    def getFrame(self):
        if (self.last_ready is not None) and (self.last_frame is not None):
            return self.last_frame.copy()
        else:
            return None


def test(RTSP_URL):
    cap = Camera(RTSP_URL)
    while True:
        time.sleep(2)
        frame = cap.getFrame()
        print(frame)


if __name__ == "__main__":
    test(
        RTSP_URL=''
    )
